#ifndef BASE_OBSERVABLE_H_
#define BASE_OBSERVABLE_H_

#include <cstddef> // NULL
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>

#include <boost/archive/tmpdir.hpp>

#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/utility.hpp>
#include <boost/serialization/list.hpp>
#include <boost/serialization/assume_abstract.hpp>

#include "base.h"

/////////////////////////////////////////////////////////////
// One bus stop
//
// illustrates serialization of serializable members
//

class base_observable
{
  friend class boost::serialization::access;
  template<class Archive>
    void serialize(Archive &ar, const unsigned int version)
    {
    }
 protected:
  
 public:
  virtual void attach(base* observer_p) = 0;
  virtual void detach(base* observer_p) = 0;
  base_observable();
  virtual ~base_observable() = 0;
};

inline base_observable::base_observable() { }
inline base_observable::~base_observable() { }

BOOST_SERIALIZATION_ASSUME_ABSTRACT(base_observable)

#endif

