#ifndef DERIVED_1_H_
#define DERIVED_1_H_

#include <cstddef> // NULL
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>

#include <boost/archive/tmpdir.hpp>

#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/utility.hpp>
#include <boost/serialization/list.hpp>
#include <boost/serialization/assume_abstract.hpp>

#include "base.h"

/////////////////////////////////////////////////////////////
// Several kinds of bus stops
//
// illustrates serialization of derived types
//
class derived_1 : public base
{
    friend class boost::serialization::access;
    int longitude;
    int latitude;
    std::string street1;
    std::string street2;
    std::string street3;

    template<class Archive>
    void serialize(Archive &ar, const unsigned int version)
    {
        // save/load base class information
        ar & boost::serialization::base_object<base>(*this);
        ar & street1 & street2 & street3;
    }

public:
    derived_1();
    derived_1(const int & _lat, const int & _long,
	      const std::string & _s1, const std::string & _s2,
	      const std::string & _s3 );
    void update();

};


#endif
