#include <string>

#include "derived.h"
#include "composite.h"
#include "derived_1.h"
#include "observable.h"

void save_schedule(const composite &s, const observable &o, const char * filename){
    // make an archive
    std::ofstream ofs(filename);
    boost::archive::text_oarchive oa(ofs);
    oa << o;
    oa << s;
}
#if 1
void restore_schedule(const composite &s, const observable &o, const char * filename)
{
  // open the archive
  std::ifstream ifs(filename);
  boost::archive::text_iarchive ia(ifs);
  
  // restore the schedule from the archive
  //    ia >> o;
  ia >> s;
}

#endif
int main(int argc, char *argv[])
{   
  
  observable funny;
  composite my_comps;

  base *bs0 = NULL;
  base *bs1 = NULL;
  base *bs2 = NULL;
  base *bs3 = NULL;

  std::string filename(boost::archive::tmpdir());
  filename += "/demofile.txt";
  


  if( std::string(argv[1]) == "--save" ) {
    // fill in the data
    // make a few stops
    bs0 = new derived(
        34,
        134,
        "24th Street", "10th Avenue"
    );
    bs1 = new derived(
        35,
        133,
        "State street", "Cathedral Vista Lane"
    );


    bs2 = new derived_1(
        35,
        133,
        "State street", "Cathedral Vista Lane", "Mikael"
    );

    bs3 = new derived_1(
        35,
        133,
        "State street", "Cathedral Vista Lane", "Mikael"
    );

    my_comps.append(bs0);
    my_comps.append(bs1);
    my_comps.append(bs2);
    my_comps.append(bs3);

    funny.attach(bs0);

    // save the schedule
    save_schedule(my_comps, funny, filename.c_str());


  }
  else if( std::string(argv[1]) == "--load" ) {
    restore_schedule(my_comps, funny, filename.c_str());
  }
  else {
    std::cout << "Please state --save or --load" << std::endl;
    return 0;
  }



  delete bs0;
  delete bs1;
  delete bs2;
  delete bs3;
  
  
  return 0;
}
