#ifndef OBSERVABLE_H_
#define OBSERVABLE_H_

#include <cstddef> // NULL
#include <iomanip>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#include <boost/archive/tmpdir.hpp>

#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/utility.hpp>
#include <boost/serialization/list.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/assume_abstract.hpp>

#include "base_observable.h"
#include "base.h"
#include "derived.h"
#include "derived_1.h"



/////////////////////////////////////////////////////////////
// One bus stop
//
// illustrates serialization of serializable members
//

class observable : public base_observable
{
  friend class boost::serialization::access;
  template<class Archive>
    void serialize(Archive &ar, const unsigned int version)
    {
      ar.register_type(static_cast<derived *>(NULL));      
      ar.register_type(static_cast<derived_1 *>(NULL));      
      ar & observer_vect;
    }
  std::vector<base*> observer_vect;
 protected:
  
 public:
  void attach(base* observer_p);
  void detach(base* observer_p);
  observable();
  ~observable();
};



#endif

